
<!DOCTYPE html>

<html lang="it">
  <head>
    <meta charset="utf-8" />
    <title>Scrivere la documentazione &#8212; Introduzione a Sphinx 1.0.0 documentazione</title>
    <link rel="stylesheet" href="../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script src="../_static/language_data.js"></script>
    <script src="../_static/translations.js"></script>
    <link rel="index" title="Indice" href="../genindex.html" />
    <link rel="search" title="Cerca" href="../search.html" />
    <link rel="next" title="MarkDown" href="configurazione.html" />
    <link rel="prev" title="Installazione di Spinx" href="installazione.html" />
   
  <link rel="stylesheet" href="../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <div class="section" id="scrivere-la-documentazione">
<h1>Scrivere la documentazione<a class="headerlink" href="#scrivere-la-documentazione" title="Link a questa intestazione">¶</a></h1>
<p>Finalmente è arrivato il momento di iniziare a scrivere.</p>
<p>La documentazione è suddivisa in pagine. Ogni pagina compare nella
<em>&quot;Table of content&quot;</em> che di solito è una colonna che compare sulla destra o
sulla sinistra del testo principale. Quando si aprono le pagine, il menù di
navigazione si apre includendo l'albero dei titoli che corrisponde al livello
dei titoli html.</p>
<p>Le pagine sono organizzate in modo gerarchico e da ogni pagina può partire un
sotto albero di documentazione.</p>
<p>Come avrete potuto constatare dalla documentazione ufficiale, nonostante sia
abbastanza facile scrivere i primi testi, il sistema è piuttosto articolato
con molte opzioni e può essere difficile da padroneggiare a fondo.</p>
<p>In questo tutorial perciò esamineremo solo alcune delle moltissime possibilità
che offre, e data la vastità dei testi, non includeremo quì i testi completi,
ma solo gli elementi sintattici esaminati. Comunque renderemo disponibili gli
esempi completi ed anche il testo di questa documentazione.</p>
<div class="section" id="qualche-cenno-di-restructuredtext">
<h2>Qualche cenno di RestructuredText<a class="headerlink" href="#qualche-cenno-di-restructuredtext" title="Link a questa intestazione">¶</a></h2>
<p>Come dicevamo in precedenza, il linguaggio di markup privilegiato di Sphinx
è <a class="reference external" href="https://docutils.sourceforge.io/rst.html">RestructuredText</a>. La sintassi
non è complessa ma nemmeno banale ed offre una grande versatilità.</p>
<p>Un buon punto di partenza per imparare è l'<a class="reference external" href="http://www.sphinx-doc.org/en/master/usage/restructuredtext/basics.html">introduzione</a>
che si trova nella documentazione di Sphinx.</p>
<p>Non vale la pena quindi di ripetere quanto già scritto molto meglio di quanto
potrei fare io. Può invece essere utile focalizzare l'attenzione su alcuni
aspetti che riguardano la metodologia di lavoro.</p>
<p>In ogni caso nel progetto di prova ho messo alcuni esempi commentati di molte
delle funzionalità presentate. Ed anche il sorgente del presente testo può
essere esaminato per ricavare spunti.</p>
<div class="section" id="commenti">
<h3>Commenti<a class="headerlink" href="#commenti" title="Link a questa intestazione">¶</a></h3>
<p>I commenti sono sempre fondamentali in ogni progetto. In rst, i commenti si
inseriscono scrivendo due punti sulla sinistra e tenendo indentato tutto il
testo commentato, ad esempio:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">..</span> <span class="n">questo</span> <span class="n">è</span> <span class="n">un</span> <span class="n">commento</span>
   <span class="n">su</span> <span class="n">due</span> <span class="n">righe</span>
</pre></div>
</div>
</div>
<div class="section" id="intestazioni">
<h3>Intestazioni<a class="headerlink" href="#intestazioni" title="Link a questa intestazione">¶</a></h3>
<p>In rst le Intestazioni si indicano sottolineando i titoli. Per ogni livello
di intestazione si usa un carattere di sottolineatura diverso e l'ordine in cui
si presentano indica il livello. Se si desidera si può inserire la
sottolineatura anche sopra. Ad esempio:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">=========</span>
<span class="n">Header</span> <span class="n">H1</span>
<span class="o">=========</span>

<span class="n">Header</span> <span class="n">H2</span>
<span class="o">---------</span>

<span class="n">Header</span> <span class="n">H3</span>
<span class="o">+++++++++</span>

<span class="n">Header</span> <span class="n">H3</span>
<span class="o">+++++++++</span>

<span class="n">Header</span> <span class="n">H2</span>
<span class="o">---------</span>

<span class="n">Header</span> <span class="n">H3</span>
<span class="o">+++++++++</span>
</pre></div>
</div>
<p>Le intestazioni sono importanti perché vengono usate da Sphinx per costruire
l'albero dell'indice.</p>
</div>
<div class="section" id="paragrafi">
<h3>Paragrafi<a class="headerlink" href="#paragrafi" title="Link a questa intestazione">¶</a></h3>
<p>In rst un paragrafo è un insieme di righe di testo senza righe vuote con la
stessa indentazione. Ad esempio</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">paragrafo</span> <span class="n">su</span>
<span class="n">due</span> <span class="n">linee</span>

   <span class="n">paragrafo</span>
   <span class="n">indentato</span>
   <span class="n">su</span> <span class="n">tre</span> <span class="n">linee</span>
</pre></div>
</div>
</div>
<div class="section" id="elementi-tipografici">
<h3>Elementi tipografici<a class="headerlink" href="#elementi-tipografici" title="Link a questa intestazione">¶</a></h3>
<p>Naturalmente si possono inserire elementi tipografici come ad esempio
<em>corsivo</em>, <strong>grassetto</strong> e <code class="docutils literal notranslate"><span class="pre">codice</span> <span class="pre">a</span> <span class="pre">dimensione</span> <span class="pre">fissa</span></code></p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>.. si scrivono così

*corsivo*, **grassetto** e ``codice a dimensione fissa``
</pre></div>
</div>
<p>Il sottolineato non è previsto per evitare confusione con i links.</p>
</div>
<div class="section" id="liste">
<h3>Liste<a class="headerlink" href="#liste" title="Link a questa intestazione">¶</a></h3>
<p>Si possono anche inserire liste puntate e numerate con diversi automatismi.
la piu semplice è:</p>
<ul class="simple">
<li><p>Mele</p></li>
<li><p>Pere</p></li>
<li><p>Albicocche</p></li>
</ul>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">-</span> <span class="n">Mele</span>
<span class="o">-</span> <span class="n">Pere</span>
<span class="o">-</span> <span class="n">Albicocche</span>
</pre></div>
</div>
</div>
<div class="section" id="tabelle">
<h3>Tabelle<a class="headerlink" href="#tabelle" title="Link a questa intestazione">¶</a></h3>
<p>Anche le tabelle hanno alcuni parametri di configurazione, ma ad esempio:</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 56%" />
<col style="width: 44%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>Prodotto</p></th>
<th class="head"><p>Quantità</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>Mele</p></td>
<td><p>kg. 1.5</p></td>
</tr>
<tr class="row-odd"><td><p>Pere</p></td>
<td><p>kg. 1</p></td>
</tr>
<tr class="row-even"><td><p>Albicocche</p></td>
<td><p>kg. 2</p></td>
</tr>
</tbody>
</table>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">==========</span>  <span class="o">========</span>
<span class="n">Prodotto</span>    <span class="n">Quantità</span>
<span class="o">==========</span>  <span class="o">========</span>
<span class="n">Mele</span>        <span class="n">kg</span><span class="o">.</span> <span class="mf">1.5</span>
<span class="n">Pere</span>        <span class="n">kg</span><span class="o">.</span> <span class="mi">1</span>
<span class="n">Albicocche</span>  <span class="n">kg</span><span class="o">.</span> <span class="mi">2</span>
<span class="o">==========</span>  <span class="o">========</span>
</pre></div>
</div>
</div>
<div class="section" id="links">
<h3>Links<a class="headerlink" href="#links" title="Link a questa intestazione">¶</a></h3>
<p>Si possono distinguere due tipi di link, i link interni e quelli esterni.</p>
<p>I <strong>link interni</strong> sono relativi alla documentazione, in modo che spostando i
files html compilati i link continuino a funzionare.</p>
<p>Per identificare le pagine si usa il comando <cite>:doc:</cite> ad esempio
<a class="reference internal" href="glossario.html"><span class="doc">Glossario</span></a> oppure si può identificare una posizione precisa
inserendo una label nel punto di destinazione e poi un comando <cite>:ref:</cite> nel
punto di chiamata ad esempio <a class="reference internal" href="premessa.html#md-ref"><span class="std std-ref">Linguaggi intermedi (Markdown e rst)</span></a></p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>.. punto di destinazione, da notare il carattere sottolineato iniziale
   che deve essere tolto nel link di chiamata.

.. _md_ref:

Markdown
........

.. chiamata

:ref:`md_ref` oppure  :ref:`Il linguaggio MarkDown &lt;md_ref&gt;`

posso chiamare una pagina con. :doc:`/pagine/glossario`

.. immagine

.. image:: _static/sphinxheader.png
</pre></div>
</div>
<p>I <strong>link esterni</strong> invece permettono di inserire la URL delle pagine esterne.
La cosa più semplice è quella di inserire nel testo la url completa senza
modifiche ad esempio <a class="reference external" href="https://www.python.org/">https://www.python.org/</a> ed in tal caso il testo
corrisponde alla URL</p>
<p>Oppure si puo inserire un testo a piacere usando una sintassi specifica ad
esempio <a class="reference external" href="https://www.python.org/">Il linguaggio Python</a></p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>.. ecco un link esterno esplicito

https://www.python.org/

.. oppure con un testo proprio

`Il linguaggio Python &lt;https://www.python.org/&gt;`_

.. da notare lo spazio tra il testo ed il link ed il carattere di
   sottolineature finale.
</pre></div>
</div>
<p>Per gli altri elementi rimandiamo alla documentazione ufficiale</p>
</div>
<div class="section" id="blocchi-di-codice">
<h3>Blocchi di codice<a class="headerlink" href="#blocchi-di-codice" title="Link a questa intestazione">¶</a></h3>
<p>Quando si scrive documentazione tecnica, si inseriscono molto spesso blocchi di
codice che devono essere riportati in modo letterale e possibilmente
evidenziati in modo diverso dal resto del codice. Ecco un esempio:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="p">::</span>

    <span class="c1"># questo è un pezzo di codice python</span>
    <span class="k">def</span> <span class="nf">foo</span><span class="p">():</span>
        <span class="k">return</span> <span class="s2">&quot;bar&quot;</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="la-struttura-del-progetto">
<h2>La struttura del progetto<a class="headerlink" href="#la-struttura-del-progetto" title="Link a questa intestazione">¶</a></h2>
<p>Un progetto Sphinx è organizzato a pagine.</p>
<p>Ogni pagina per essere visibile deve essere inclusa in una &quot;Table of contents&quot;
con la direttiva <code class="docutils literal notranslate"><span class="pre">..</span> <span class="pre">toctree::</span></code>, poi nell'indice verranno inclusi i
sottolivelli determinati dai livelli di intestazione.</p>
<p>Per maggiore convenienza, le pagine possono essere contenute in sottocartelle
e nel <code class="docutils literal notranslate"><span class="pre">..</span> <span class="pre">toctree::</span></code> si dovrà indicare il percorso completo ma relativo alla
pagina chiamante.</p>
<p>Ogni pagina può avere un proprio <code class="docutils literal notranslate"><span class="pre">..</span> <span class="pre">toctree::</span></code> ed in questo modo si possono
strutturare gerarchie di documentazione.</p>
<p>Il sistema è in grado di generare automaticamente alcune pagine che sono:</p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">genindex</span></code> Indice analitico</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">modindex</span></code> Indice dei moduli python</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">search</span></code> Pagina per le ricerche</p></li>
</ul>
<p>Per i dettagli consultare la documentazione</p>
</div>
<div class="section" id="roles-directives-domains">
<h2>Roles, Directives, Domains<a class="headerlink" href="#roles-directives-domains" title="Link a questa intestazione">¶</a></h2>
<p>Elencare in modo esaustivo tutte le funzionalità di Sphinx non è lo scopo di
questa documentazione. Il nostro scopo è quello di fornire gli strumenti per
cercare quello che può servire.</p>
<p>Per questo motivo accenniamo solamente alcune delle caratteristiche che si
possono attivare utilizzando rst. Alcune le abbiamo già viste.</p>
<p>Le <strong>Roles</strong> (Regole) sono parole racchiuse tra due segni dei due punti, ne
abbiamo viste alcune ad esempio <code class="docutils literal notranslate"><span class="pre">:ref:</span></code> e  <code class="docutils literal notranslate"><span class="pre">:doc:</span></code> parlando dei link
interni.</p>
<p>Altra regola interessante è <code class="docutils literal notranslate"><span class="pre">:abbr:</span></code> che permette di gestire abbreviazioni ed
acronimi, ad esempio <code class="docutils literal notranslate"><span class="pre">:abbr:`OS</span> <span class="pre">(Operating</span> <span class="pre">System)`</span></code> visualizza la parola
<cite>OS</cite> e fa un popup con <cite>(Operating System)</cite></p>
<p>Molto utili sono anche le <code class="docutils literal notranslate"><span class="pre">substitutions</span></code> che permettono di scrivere campi
variabili ad esempio posso dichiarare:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">..</span> <span class="o">|</span><span class="n">my_url</span><span class="o">|</span> <span class="n">replace</span><span class="p">::</span> <span class="n">https</span><span class="p">:</span><span class="o">//</span><span class="n">mywebagency</span><span class="o">.</span><span class="n">com</span>
</pre></div>
</div>
<p>e poi richiamarle nel testo con <code class="docutils literal notranslate"><span class="pre">|my_url|</span></code> se in seguito decido di cambiare
la url è sufficiente cambiare solo la definizione.</p>
<p>Le <strong>Directives</strong> (Direttive) sono comandi che iniziano con due punti <code class="docutils literal notranslate"><span class="pre">..</span></code> ad inizio
riga alcune le abbiamo già viste, ad esempio <code class="docutils literal notranslate"><span class="pre">..</span> <span class="pre">toctree::</span></code> altre si
trovano nella documentazione, ad esempio <code class="docutils literal notranslate"><span class="pre">..</span> <span class="pre">note::</span></code>, <code class="docutils literal notranslate"><span class="pre">..</span> <span class="pre">versionadd::</span></code>
<code class="docutils literal notranslate"><span class="pre">..</span> <span class="pre">deprecated::</span></code> ed altre.</p>
<p>I <strong>Domains</strong> (Domini) come recita il manuale sono collezioni di directives e
roles che appartengono ad uno stesso gruppo ad esempio gli elementi di un
linguaggio di programmazione.</p>
<p>Sphinx integra domains per alcuni linguaggi di programmazione ed ambienti tra
cui Python, C, JavaScript RestructuredText, Math ed altri. Altri ancora
sono stati resi disponibili come estensioni di terze parti.</p>
</div>
</div>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../index.html">Introduzione a Sphinx</a></h1>








<h3>Navigazione</h3>
<p class="caption"><span class="caption-text">Contenuto:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="premessa.html">Premessa</a></li>
<li class="toctree-l1"><a class="reference internal" href="installazione.html">Installazione di Spinx</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Scrivere la documentazione</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#qualche-cenno-di-restructuredtext">Qualche cenno di RestructuredText</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#commenti">Commenti</a></li>
<li class="toctree-l3"><a class="reference internal" href="#intestazioni">Intestazioni</a></li>
<li class="toctree-l3"><a class="reference internal" href="#paragrafi">Paragrafi</a></li>
<li class="toctree-l3"><a class="reference internal" href="#elementi-tipografici">Elementi tipografici</a></li>
<li class="toctree-l3"><a class="reference internal" href="#liste">Liste</a></li>
<li class="toctree-l3"><a class="reference internal" href="#tabelle">Tabelle</a></li>
<li class="toctree-l3"><a class="reference internal" href="#links">Links</a></li>
<li class="toctree-l3"><a class="reference internal" href="#blocchi-di-codice">Blocchi di codice</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#la-struttura-del-progetto">La struttura del progetto</a></li>
<li class="toctree-l2"><a class="reference internal" href="#roles-directives-domains">Roles, Directives, Domains</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="configurazione.html">MarkDown</a></li>
<li class="toctree-l1"><a class="reference internal" href="configurazione.html#configurazione">Configurazione</a></li>
<li class="toctree-l1"><a class="reference internal" href="configurazione.html#documentazione-di-python">Documentazione di Python</a></li>
<li class="toctree-l1"><a class="reference internal" href="configurazione.html#estensioni-di-sphinx">Estensioni di Sphinx</a></li>
<li class="toctree-l1"><a class="reference internal" href="glossario.html">Glossario</a></li>
<li class="toctree-l1"><a class="reference internal" href="risorse.html">Risorse</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../index.html">Documentation overview</a><ul>
      <li>Previous: <a href="installazione.html" title="capitolo precedente">Installazione di Spinx</a></li>
      <li>Next: <a href="configurazione.html" title="capitolo successivo">MarkDown</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Ricerca veloce</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Vai" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2020, Claudio Driussi.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 3.0.1</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="../_sources/pagine/scrivere.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>